# Script for font generation
# Copyright (C) 2004,2005 Thomas Mathys (killer@vantage.ch)
#
# This file is part of rfk7800.
#
# rfk7800 is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# rfk7800 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with rfk7800; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# This script generates the font data. The input file's format
# is the same as VGA font data. The output format is 1bpp,
# laid out for indirect mode.
#
require "readbytes"

begin

  if ARGV.length != 3
    raise StandardError, "Wrong arguments.\nUsage : #{__FILE__} <inputfile> <nchars> <charheight>"
  end
  NCHARS = ARGV[1].to_i
  CHARHEIGHT = ARGV[2].to_i
  
  data = File.open(ARGV[0], "rb") do |file|
    file.readbytes(NCHARS * CHARHEIGHT)
  end

  puts "\t.export\t_font"
  puts "\t.segment \"RODATA\""
  puts "\t.align\t256"
  puts "_font:"

  (CHARHEIGHT-1).downto(0) do |row|
    NCHARS.times do |char|    
      printf "\t.byte\t$%02x\n", data[char*CHARHEIGHT+row]
    end
  end

  exit 0
rescue StandardError => e
  $stderr.puts "Argh : #{e}"
  exit 1
end

begin
  
rescue StandardError => e
  $stderr.puts "Argh : #{e}"
end
