; Startupcode for the Atari 7800
; Copyright (C) 2004,2005 Thomas Mathys (killer@vantage.ch)
;
; This file is part of rfk7800.
;
; rfk7800 is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; rfk7800 is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with rfk7800; if not, write to the Free Software
; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
;
        .export _exit
        .export _zonecounter
        .import __ROM_START__
        .import __RAM3_START__, __RAM3_SIZE__
        .import initlib, donelib
        .import zerobss, copydata
        .import push0, _main
        .include "zeropage.inc"


INPTCTRL        =       $01
OFFSET          =       $38
CTRL            =       $3c


        .segment "STARTUP"
start:
        ; Startup sequence recommended by Atari.
        ; See the 7800 standards document.
        sei                     ; Initialize 6502
        cld
        lda     #$07            ; Lock machine in 7800 mode
        sta     INPTCTRL                
        lda     #$7f            ; DMA off
        sta     CTRL
        ldx     #0              ; OFFSET must always be 0
        stx     OFFSET
        stx     INPTCTRL        ; Make sure joysticks don't freeze
        dex                     ; Stack pointer = $ff
        txs

        ; Set up parameter stack        
        lda     #<(__RAM3_START__ + __RAM3_SIZE__)
        sta     sp
        lda     #>(__RAM3_START__ + __RAM3_SIZE__)
        sta     sp+1

        jsr     copydata
        jsr     zerobss
        jsr     initlib

        ; Call main program (pass empty command line)
        jsr     push0           ; argc
        jsr     push0           ; argv
        ldy     #4              ; Argument size
        jsr     _main

_exit:
        jsr     donelib
        jmp     start

NMIHandler:        
        inc     _zonecounter
        rti

IRQHandler:
        rti

        .segment "DATA"
_zonecounter:
        .byte   0

        .segment "ENCRYPTION"
        .res    126, $ff        ; Reserved for encryption
Lfff8:  .byte   $ff             ; Region verification (always $ff)
Lfff9:  .byte   $f7             ; Use last 4096 bytes only for encryption
;;;Lfff9:  .byte   <(((__ROM_START__/4096)<<4) | 7)


        .segment "VECTORS"
        .word   NMIHandler
        .word   start
        .word   IRQHandler
